Index: /Dev/trunk/src/server/app.js
===================================================================
--- /Dev/trunk/src/server/app.js	(revision 524)
+++ /Dev/trunk/src/server/app.js	(revision 525)
@@ -961,41 +156,4 @@
 
     return app;
-}
-
-function writeObjectsToCSVStream(objects, stream, prelude) {
-    var keys = _.chain(objects)
-                .map(_.keys)
-                .flatten()
-                .uniq()
-                .value();
-    var idxs = {};
-    _.forEach(keys, function(key,idx){
-        idxs[key] = idx;
-    });
-    var writer = new CSV.CsvWriter(stream);
-    if ( prelude ) {
-        _.forEach(prelude, function(val,key){
-            writer.writeRecord([key,val]);
-        });
-    }
-    writer.writeRecord(keys);
-    _.forEach(objects, function(obj){
-        var row = [];
-        _.forEach(obj, function(val,key){
-            row[idxs[key]] = val;
-        });
-        writer.writeRecord(row);
-    });
-}
-
-function randomToken() {
-    var result = new HTTPResult();
-    cryptoken(8)
-    .then(function(token){
-        result.set(201,token);
-    }, function(ex){
-        result.set(500,{error:"Cannot generate secrets.", innerError: ex});
-    });
-    return result;
 }
 
Index: /Dev/trunk/src/server/bin/heroku.js
===================================================================
--- /Dev/trunk/src/server/bin/heroku.js	(revision 524)
+++ /Dev/trunk/src/server/bin/heroku.js	(revision 525)
@@ -6,5 +6,5 @@
 console.log("Using CouchDB on",env.couchServerURL+env.dbName);
 
-require('../app').App(env)
+require('../app').app(env)
 .then(function(app){
     app.listen(env.port, function() {
Index: /Dev/trunk/src/server/bin/upgrade-db-1-to-2.js
===================================================================
--- /Dev/trunk/src/server/bin/upgrade-db-1-to-2.js	(revision 524)
+++ /Dev/trunk/src/server/bin/upgrade-db-1-to-2.js	(revision 525)
@@ -1,15 +1,17 @@
 var env = require('../env')
+  , HTTPResult = require('../util/http-result')
   , upgradeCouch = require('../config/upgrade-couchdb')
   , cryptoken = require('../util/crypto-token')
-  , Q = require('q')
   ;
 upgradeCouch(env.couchServerURL,env.dbName,function(doc){
-    if ( (doc.type === 'Response' || doc.type === 'SurveyRun') && !doc.secret ) {
-        return cryptoken(8).then(function(token){
+    if ( (doc.type === 'Response' || doc.type === 'SurveyRun') &&
+         !doc.secret ) {
+        return cryptoken()
+        .then(function(token){
             doc.secret = token;
             return doc;
         });
     } else {
-        return Q.reject();
+        return new HTTPResult(-1);
     }
 }).then(function(res){
Index: /Dev/trunk/src/server/bin/upgrade-db-2-to-3.js
===================================================================
--- /Dev/trunk/src/server/bin/upgrade-db-2-to-3.js	(revision 524)
+++ /Dev/trunk/src/server/bin/upgrade-db-2-to-3.js	(revision 525)
@@ -2,5 +2,5 @@
   , upgradeCouch = require('../config/upgrade-couchdb')
   , cryptoken = require('../util/crypto-token')
-  , Q = require('q')
+  , HTTPResult = require('../util/http-result')
   , _ = require('underscore')
   ;
@@ -51,5 +51,5 @@
         return doc;
     } else {
-        return Q.reject();
+        return new HTTPResult(-1);
     }
 }).then(function(res){
Index: /Dev/trunk/src/server/bin/upgrade-db-3-to-4.js
===================================================================
--- /Dev/trunk/src/server/bin/upgrade-db-3-to-4.js	(revision 524)
+++ /Dev/trunk/src/server/bin/upgrade-db-3-to-4.js	(revision 525)
@@ -2,5 +2,5 @@
   , upgradeCouch = require('../config/upgrade-couchdb')
   , cryptoken = require('../util/crypto-token')
-  , Q = require('q')
+  , HTTPResult = require('../util/http-result')
   , _ = require('underscore')
   ;
@@ -25,5 +25,5 @@
         return doc;
     } else {
-        return Q.reject();
+        return HTTPResult.fail();
     }
 }).then(function(res){
Index: /Dev/trunk/src/server/bin/upgrade-db-codes-2014-03-18.js
===================================================================
--- /Dev/trunk/src/server/bin/upgrade-db-codes-2014-03-18.js	(revision 525)
+++ /Dev/trunk/src/server/bin/upgrade-db-codes-2014-03-18.js	(revision 525)
@@ -0,0 +1,153 @@
+var env = require('../env')
+  , upgradeCouch = require('../config/upgrade-couchdb')
+  , cryptoken = require('../util/crypto-token')
+  , HTTPResult = require('../util/http-result')
+  , _ = require('underscore')
+  ;
+
+var qcodeMap = {
+    PT1GF: 'ST1GF'
+};
+
+var subcodeMap = {
+    SAPY: { // really called, team psychological safety
+        10: '1',
+        11: '2',
+        12: '3',
+        13: '4',
+        14: '5',
+        15: '6',
+        16: '7'
+    },
+    SAPI2: {
+        1: ''
+    },
+    PT1GF: {
+        10: '1',
+        11: '2',
+        12: '3',
+        13: '4',
+        14: '5',
+        15: '10',
+        16: '11'
+    },
+    SVAG12: {
+        0: ''
+    },
+    SVTCQ: {
+        10: '1',
+        11: '2',
+        12: '3',
+        13: '4',
+        14: '5',
+        15: '6',
+        16: '7',
+        17: '8',
+        18: '9',
+        19: '10',
+        110: '11',
+        111: '12',
+        112: '13',
+        113: '14',
+        114: '15',
+        115: '16'
+    },
+    SAGE: {
+        10: '1',
+        11: '2',
+        12: '3',
+        13: '4',
+        14: '5',
+        15: '6',
+        16: '7',
+        17: '8',
+        18: '9',
+        19: '10',
+        110: '11',
+        111: '12',
+        112: '13',
+        113: '14',
+        114: '15',
+        115: '16',
+        116: '17',
+        117: '18'
+    },
+    SAPI1: {
+        10: 'a',
+        11: 'b',
+        12: 'c',
+        13: 'd'
+    },
+    SVAG2: {
+        0: ''
+    },
+    GROUPID: {
+        0: ''
+    },
+    RESPONDENTID: {
+        0: ''
+    }
+};
+
+var fullcodeMap = {};
+_.each(subcodeMap, function(subcodes,oldCode){
+    var newCode = oldCode in qcodeMap ? qcodeMap[oldCode] : oldCode;
+    _.each(subcodes,function(newSubcode,oldSubcode){
+        fullcodeMap[oldCode+oldSubcode] = newCode+newSubcode;
+    });
+});
+
+function rewriteQuestion(question) {
+    if ( question.code in subcodeMap ) {
+        rewriteContent(question.content,subcodeMap[question.code]);
+    }
+    if ( question.code in qcodeMap ) {
+        question.code = qcodeMap[question.code];
+    }
+}
+
+function rewriteContent(obj,map) {
+    if ( _.isObject(obj) ) {
+        if ( 'subcode' in obj && obj.subcode in map ) {
+            obj.subcode = map[obj.subcode];
+        }
+        _.each(obj,function(item){
+            rewriteContent(item,map);
+        });
+    }
+}
+
+function rewriteAnswers(answers) {
+    _.each(answers,function(answer,code){
+        if ( code in fullcodeMap ) {
+            delete answers[code];
+            answers[fullcodeMap[code]] = answer;
+        }
+    });
+}
+
+function rewriteDoc(doc) {
+    switch(doc.type) {
+    case 'SurveyRun':
+        _.each(doc.survey.questions,rewriteQuestion);
+        return doc;
+    case 'Survey':
+        _.each(doc.questions,rewriteQuestion);
+        return doc;
+    case 'Question':
+        rewriteQuestion(doc);
+        return doc;
+    case 'Response':
+        rewriteAnswers(doc.answers);
+        return doc;
+    default:
+        return HTTPResult.fail();
+    }
+}
+
+upgradeCouch(env.couchServerURL,env.dbName,rewriteDoc)
+.then(function(res){
+    console.log("done",res);
+}, function(err){
+    console.error("fail",err);
+});
Index: /Dev/trunk/src/server/config/check-couchdb.js
===================================================================
--- /Dev/trunk/src/server/config/check-couchdb.js	(revision 524)
+++ /Dev/trunk/src/server/config/check-couchdb.js	(revision 525)
@@ -1,6 +1,7 @@
-var Q = require('q')
-  , _ = require('underscore')
+var _ = require('underscore')
+  , HTTPResult = require('../util/http-result')
   , validator = require('../util/validator')
-  , CouchDB = require('../util/couch').CouchDB
+  , CouchDB = require('../util/couch')
+  , objF = require('../util/object')
   ;
 
@@ -10,14 +11,4 @@
     var server = new CouchDB(couchServerURL,dbName);
     var designRe = /^_design\//;
-
-    var codes = {};
-    function codeUnique(code) {
-        if ( code in codes ) {
-            return false;
-        } else {
-            codes[code] = true;
-            return true;
-        }
-    }
 
     return server.get('/_all_docs')
@@ -32,14 +23,21 @@
                 .then(function(doc){
                     var valid = validator(doc,schema);
-                    if ( doc.type === "Question" && !codeUnique(doc.code) ) {
-                        valid.valid = false;
-                        valid.error = "Question code "+doc.code+" is not unique.";
-                    }
                     result[doc._id] = valid;
                     return result;
                 });
             });
-        }, Q.resolve({}))
+        }, new HTTPResult(200,{}))
         .value();
-    }).all();
+    }).then(function(result){
+        return server.get('_design/questions/_view/all_variables')
+        .then(function(variables){
+            var dups = objF.findDuplicates(
+                variables.rows,
+                function(row){ return row.key; });
+            result._duplicateVariables = _.groupBy(
+                dups,
+                function(dup){ return dup.key; });
+            return result;
+        });
+    });
 };
Index: /Dev/trunk/src/server/config/config-couchdb.js
===================================================================
--- /Dev/trunk/src/server/config/config-couchdb.js	(revision 524)
+++ /Dev/trunk/src/server/config/config-couchdb.js	(revision 525)
@@ -1,5 +1,5 @@
-var Q = require('q')
+var HTTPResult = require('../util/http-result')
   , _ = require('underscore')
-  , CouchDB = require('../util/couch').CouchDB
+  , CouchDB = require('../util/couch')
   , util = require('util')
   ;
@@ -62,5 +62,5 @@
                 }
             });
-        }, Q.resolve());
+        }, new HTTPResult(200));
     });
 };
Index: /Dev/trunk/src/server/config/couchdb-design-docs.js
===================================================================
--- /Dev/trunk/src/server/config/couchdb-design-docs.js	(revision 524)
+++ /Dev/trunk/src/server/config/couchdb-design-docs.js	(revision 525)
@@ -1,2 +1,28 @@
+var fs = require('fs')
+  , path = require('path')
+  ;
+
+function readModule(name) {
+    var filename;
+    if ( name.indexOf('.') === 0 ) {
+        filename = path.join(path.dirname(module.filename),name+'.js');
+    } else {
+        var dirname = path.join(path.dirname(module.filename),
+                                '../../node_modules',name);
+        filename = path.join(dirname,name+'.js');
+        var pkgfile = path.join(dirname,'package.json');
+        if ( fs.exists(pkgfile) ) {
+            var pkg = require(pkgfile);
+            if ( pkg.main ) {
+                filename = path.join(dirname,pkg.main);
+            }
+        }
+    }
+    var src = fs.readFileSync(filename, 'utf8');
+    src = src.replace(/require\s*\(\s*(['\"])([^'"]*)(['\"])\s*\)/g,
+                      'require($1views/lib/$2$3)');
+    return src;
+}
+
 module.exports = {
 
@@ -80,4 +106,32 @@
                 reduce: function(key, values, rereduce) { return sum(values); }
             },
+            all_variables: {
+                map: function(doc) {
+                    if ( doc.type !== 'Question' ) { return; }
+                    var _ = require('views/lib/underscore');
+                    var objF = require('views/lib/object');
+                    _.chain(objF.collectFields('subcode',doc.content))
+                    .map(function(subcode){
+                        return doc.code+subcode;
+                    })
+                    .each(function(variable){
+                        emit(variable,doc._id);
+                    });
+                }
+            },
+            published_variables: {
+                map: function(doc) {
+                    if ( doc.type !== 'Question' || !doc.publicationDate ) { return; }
+                    var _ = require('views/lib/underscore');
+                    var objF = require('views/lib/object');
+                    _.chain(objF.collectFields('subcode',doc.content))
+                    .map(function(subcode){
+                        return doc.code+subcode;
+                    })
+                    .each(function(variable){
+                        emit(variable,doc._id);
+                    });
+                }
+            },
             all_by_code: {
                 map: function(doc){
@@ -91,4 +145,8 @@
                     emit(doc.code,doc);
                 }
+            },
+            lib: {
+                underscore: readModule('underscore'),
+                object: readModule('../util/object')
             }
         }
Index: /Dev/trunk/src/server/config/upgrade-couchdb.js
===================================================================
--- /Dev/trunk/src/server/config/upgrade-couchdb.js	(revision 524)
+++ /Dev/trunk/src/server/config/upgrade-couchdb.js	(revision 525)
@@ -1,5 +1,5 @@
-var Q = require('q')
+var HTTPResult = require('../util/http-result')
   , _ = require('underscore')
-  , CouchDB = require('../util/couch').CouchDB
+  , CouchDB = require('../util/couch')
   ;
 
@@ -19,5 +19,5 @@
                 return server.get(doc.id)
                 .then(function(doc){
-                    Q.when(upgrade(doc))
+                    HTTPResult.when(200,upgrade(doc))
                     .then(function(newDoc){
                         return server.put(doc._id,newDoc)
@@ -32,5 +32,5 @@
                 });
             });
-        }, Q.resolve({}))
+        }, new HTTPResult(200,{}))
         .value();
     }).all();
Index: /Dev/trunk/src/server/util/couch.js
===================================================================
--- /Dev/trunk/src/server/util/couch.js	(revision 524)
+++ /Dev/trunk/src/server/util/couch.js	(revision 525)
@@ -1,8 +1,5 @@
-var CouchDB, _ref,
-  __hasProp = {}.hasOwnProperty;
-
-var request = require('./q-request')
+var request = require('./request')
   , _ = require('underscore')
-  , Q = require('q');
+  ;
 
 function CouchDB(url, db) {
@@ -58,26 +55,9 @@
         if (opts.headers) { _.extend(options.headers, opts.headers); }
     }
-    var req = request(url, options);
-    var res = req.response
-    .then(function(res) {
-        return req.then(function(res) {
-            return JSON.parse(res);
-        }, function(err) {
-            return Q.reject(JSON.parse(err));
+    return request(url, options)
+        .handle({
+            '-1': _.identity,
+            default: function(status,result) { return JSON.parse(result); }
         });
-    }, function(err) {
-        return Q.reject(err);
-    });
-    res.response = req.response
-    .then(function(res) {
-        return {
-            statusCode: res.statusCode,
-            headers: res.headers,
-            body: JSON.parse(res.body)
-        };
-    }, function(err) {
-        return Q.reject({error:err.message});
-    });
-    return res;
 }
 
@@ -108,3 +88,3 @@
 }
 
-exports.CouchDB = CouchDB;
+module.exports = CouchDB;
Index: /Dev/trunk/src/server/util/crypto-token.js
===================================================================
--- /Dev/trunk/src/server/util/crypto-token.js	(revision 524)
+++ /Dev/trunk/src/server/util/crypto-token.js	(revision 525)
@@ -1,14 +1,12 @@
-var Q = require('q')
+var HTTPResult = require('./http-result')
   , crypto = require('crypto');
 
 module.exports = function(bytes) {
-    var q = Q.defer();
-    crypto.randomBytes(bytes || 8, function(ex, buf) {
-        if ( ex ) {
-            q.reject(ex);
-        } else {
-            q.resolve(buf.toString('hex'));
-        }
-    });
-    return q.promise;
+    bytes  =bytes || 8;
+    var result = new HTTPResult();
+    crypto.randomBytes(bytes, result.asCallback(201));
+    return result
+        .then(function(buf){
+            return buf.toString('hex');
+        });
 };
Index: /Dev/trunk/src/server/util/http-result.js
===================================================================
--- /Dev/trunk/src/server/util/http-result.js	(revision 524)
+++ /Dev/trunk/src/server/util/http-result.js	(revision 525)
@@ -1,4 +1,14 @@
-// <init> :: status? -> result? -> HTTPResult
+var _ = require('underscore')
+  ;
+
+var when;
+
+// type Callback = status:Number -> result:Any -> Either HTTPResult Any
+// type Handler = { f:Callback, next:HTTPResult }
+
+// <init> :: status:Number? -> result:Any? -> HTTPResult
+var counter = 0;
 function HTTPResult(status,result) {
+    this.id = counter++;
     this.status = 0;
     this.result = null;
@@ -9,19 +19,4 @@
 }
 
-HTTPResult.fromResponsePromise = function(promise,errorHandler) {
-    var result = new HTTPResult();
-    promise.then(function(response){
-        result.set(response.statusCode,response.body);
-    }, errorHandler && function(error){
-        var ret = errorHandler(error);
-        if ( ret.constructor === HTTPResult ) {
-            ret.handle(result.set.bind(result));
-        } else {
-            result.set(500,ret);
-        }
-    });
-    return result;
-};
-
 // isSet :: Bool
 HTTPResult.prototype.isSet = function() {
@@ -29,32 +24,34 @@
 };
 
-// set :: status -> result? -> ()
+// set :: status:Number -> result:Any? -> ()
 HTTPResult.prototype.set = function(status,result) {
-    if ( this.isSet() ) { throw new Error("Result was already set."); }
-    if ( typeof status !== 'number' ) { throw new Error("Status must be a number."); }
+    if ( this.isSet() ) {
+        throw new Error("Result was already set.");
+    }
+    if ( !_.isNumber(status) ) {
+        throw new Error("Status must be a number.");
+    }
     this.status = status;
     this.result = result;
-    for ( var i = 0; i < this._handlers.length; i++ ) {
-        this._fire(this._handlers[i]);
+    _.each(this._handlers,this._fire.bind(this));
+};
+
+// _fire :: Handler -> ()
+HTTPResult.prototype._fire = function(handler) {
+    var ret = handler.f(this.status,this.result);
+    if ( ret instanceof HTTPResult ) {
+        ret.handle(handler.next.set.bind(handler.next));
+    } else {
+        handler.next.set(this.status,ret);
     }
 };
 
-// _fire :: (status -> result -> Either HTTPResult Any) -> ()
-HTTPResult.prototype._fire = function(f) {
-    var ret = f(this.status,this.result);
-    if ( ret.constructor === HTTPResult ) {
-        ret.handle(f._next.set.bind(f._next));
-    } else {
-        f._next.set(this.status,ret);
-    }
-};
-
-/* handle :: Either (status -> result -> Either HTTPResult Any)
- *                  {number: (result -> Either HTTPResult Any),
- *                   'default': (status -> result -> Either HTTPResult Any)}
+/* handle :: Either Callback
+ *                  {status:Number*: (result -> Either HTTPResult Any),
+ *                   'default'?: Callback}
  *           -> HTTPResult
  */
 HTTPResult.prototype.handle = function(fOrObj) {
-    var f = typeof fOrObj === 'function' ?
+    var f = _.isFunction(fOrObj) ?
             fOrObj :
             function(status,result) {
@@ -67,11 +64,64 @@
                 }
             };
-    f._next = new HTTPResult();
+    var next = new HTTPResult();
+    var handler = {
+        f: f,
+        next: next
+    };
     if ( this.isSet() ) {
-        this._fire(f);
+        this._fire(handler);
     } else {
-        this._handlers.push(f);
+        this._handlers.push(handler);
     }
-    return f._next;
+    return next;
+};
+
+// then :: onSuccess:(result:Any -> status:Number)? ->
+//         onError:(result:Any -> status:Number)? -> HTTPResult
+HTTPResult.prototype.then = function(onSuccess,onError) {
+    var f = function(status,result) {
+        if ( status >= 200 && status < 300 && onSuccess ) {
+            if ( onSuccess ) {
+                result = onSuccess(result,status);
+            }
+        } else {
+            if ( onError ) {
+                result = onError(result,status);
+            }
+        }
+        return result;
+    };
+    return this.handle(f);
+};
+
+HTTPResult.prototype.asCallback = function(status) {
+    status = status || 200;
+    return function(ex,result) {
+        if ( ex ) {
+            this.set(-1,ex);
+        } else {
+            this.set(status,result);
+        }
+    }.bind(this);
+};
+
+// when :: Either HTTPResult Any -> HTTPResult
+when = HTTPResult.when = function(status,valueOrResult) {
+    status = status || 200;
+    if ( valueOrResult instanceof HTTPResult ) {
+        return valueOrResult;
+    } else {
+        return new HTTPResult(status,valueOrResult);
+    }
+};
+
+// ok :: result:Any? -> HTTPResult
+HTTPResult.ok = function(result) {
+    return new HTTPResult(200,result);
+};
+
+// fail :: error:Any? -> HTTPResult
+HTTPResult.fail = function(error) {
+    return new HTTPResult(-1,error);
 };
 
Index: /Dev/trunk/src/server/util/object.js
===================================================================
--- /Dev/trunk/src/server/util/object.js	(revision 525)
+++ /Dev/trunk/src/server/util/object.js	(revision 525)
@@ -0,0 +1,30 @@
+var _ = require('underscore')
+  ;
+
+var exportFields = exports.collectFields = function collectFields(field,obj) {
+    if ( _.isObject(obj) ) {
+        return _.reduce(obj,function(vals,val,key){
+            if ( key === field ) {
+                vals.push(val);
+            }
+            return vals.concat(collectFields(field,val));
+        },[]);
+    } else {
+        return [];
+    }
+};
+
+var findDuplicates = exports.findDuplicates = function(array,iterator) {
+    iterator = iterator || _.identity;
+    array = _.sortBy(array,iterator);
+    return _.chain(_.initial(array))
+            .zip(_.rest(array))
+            .reduce(function(dups,nAndSn){
+                if ( iterator(nAndSn[0]) === iterator(nAndSn[1]) &&
+                     nAndSn[0] !== _.last(dups) ) {
+                    return dups.concat([nAndSn[0]]);
+                }
+                return dups;
+            },[])
+            .value();
+};
Index: /Dev/trunk/src/server/util/request.js
===================================================================
--- /Dev/trunk/src/server/util/request.js	(revision 525)
+++ /Dev/trunk/src/server/util/request.js	(revision 525)
@@ -0,0 +1,24 @@
+var HTTPResult = require('./http-result')
+  , request = require('request')
+  , url = require('url')
+  , _ = require('underscore')
+  ;
+
+module.exports = function(url, options) {
+
+    var result = new HTTPResult();
+    
+    options = options ? _.clone(options) : {};
+    options.uri = url || options.uri;
+    
+    request(options,function(err,res,body){
+        if ( err ) {
+            result.set(-1,err);
+        } else {
+            result.set(res.statusCode,body);
+        }
+    });
+
+    return result;
+    
+};
